-- Depends: LastFrame

-- int K_SpectateWaitPosition (int spectatewait)
rawset (_G, "K_SpectateWaitPosition",
function (wait)
	local pos = 1
	for p in players.iterate
	do
		if (p.spectatewait > wait)
		then
			pos = $+1
		end
	end
	return pos
end)

LastFrame_Define(
{
	kartstuff =
	{
		k_spectatewait,
	},
}, "player_t")

addHook ("PlayerSpawn", function (p)
	if (p.jointime == 0)
	then
		LastFrame_Spawn(p, LastFrames.player_t)

		p.spectatewait = 0
	end
end)

for p in players.iterate
do
	LastFrame_Copy(p, LastFrames.player_t)
end

addHook ("ThinkFrame", function ()
	local left = false

	local realwait
	local     wait
	local lastwait

	for p in players.iterate
	do
		if (( p.pflags & PF_WANTSTOJOIN ))
		then
			realwait = p.spectatewait + 1
		else
			realwait = 0
		end
		-- See below on why this is necessary.
		p.spectatewait = realwait

		wait     =           p.kartstuff[k_spectatewait]
		lastwait = p.lastframe.kartstuff[k_spectatewait]

		-- Hey look at this, a hidden hack! :o Because kartstuff is cleared upon
		-- exiting the level, the following statement will trigger one tic after
		-- map load.
		if (wait == 1)
		then
			CONS_Printf(p, "\4*You are position "..
			K_SpectateWaitPosition(realwait) .." in queue.")
		end

		if (wait < lastwait)
		then
			left = true
		end

		LastFrame(p)
	end

	if (left)
	then
		for p in players.iterate
		do
			wait = p.spectatewait
			if (wait)
			then
				CONS_Printf(p, "\4*You are now position "..
				K_SpectateWaitPosition(wait) .." in queue.")
			end
		end
	end
end)
